/*
 * programs/wsetbg.c, part of W
 * (C) 94-02/96 by Torsten Scherer (TeSche)
 * itschere@techfak.uni-bielefeld.de
 *
 * changed for W1R2 by TeSche 01-11/95
 * w_readimg() moved into Wlib, TeSche 01/96
 *
 * CHANGES
 * 11/97 ++eero:
 * - As 'wbm' is now the preferred method for image output, I decided to
 * convert this into a utility with which one can set the W background
 * pattern or (in future) color.
 * 2/98 ++eero:
 * - pattern ID is now interpreted as hexadecimal.
 * - Can use now also hatch parameters.
 */

#include <stdio.h>
#include <stdlib.h>
#include <Wlib.h>


void usage(void)
{
	fprintf(stderr, "usage:\twsetbg\n\twsetbg <pattern id>\n");
	fprintf(stderr, "\twsetbg <hatch id> <line width> <times>\n");
}

/*
 * guess what...
 */

int main(long argc, char *argv[])
{
	ushort id, patt = W_PATTERN;
	WSERVER *wserver;

	if (argc > 2 && argc != 4) {
		usage();
		return -1;
	}

	if (argc == 2) {
		sscanf(argv[1], "%hx", &patt);
	}
	if (argc == 4) {
		id = w_hatch(atoi(argv[1]), atoi(argv[2]), atoi(argv[3]));
		if (!id) {
			fprintf(stderr, "wsetbg: illegal hatch parameters\n");
			usage();
			return -1;
		}
		patt = id;
	}

	if (!(wserver = w_init())) {
		fprintf(stderr, "error: can't connect to W server\n");
		return -1;
	}

	w_setmode(WROOT, M_DRAW);
	w_setpattern(WROOT, patt);
	w_dpbox(WROOT, 0, 0, wserver->width, wserver->height);
	w_flush();

	return 0;
}
