#include "Wlib.h"

/* quick integer square root from Dr. Dobbs Journal using binomial theorem */
ulong isqrt(ulong N)
{
	ulong l2, u, v, u2, n;
	if(2 > N) {
		return N;
	}
	u = N;
	l2 = 0;
	/* 1/2 * log_2 N = highest bit in the result */
	while((u >>= 2)) {
		l2++;
	}
	u = 1L << l2;
	v = u;
	u2 = u << l2;
	while(l2--) {
		v >>= 1;
		n = (u + u + v) << l2;
		n += u2;
		if(n <= N) {
			u += v;
			u2 = n;
		}
	}
	return u;
}
