/*
 * server/wfuncs_server.c, part of W
 * (C) 1994,95,96 by Torsten Scherer (TeSche)
 * itschere@techfak.uni-bielefeld.de
 *
 * these functions are known to the server only
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#ifdef __MINT__
# include <mintbind.h>
#endif
#include "config.h"
#include "types.h"
#include "pakets.h"
#include "proto.h"
#include "window.h"


/*
 * a `top' routine
 */

void w_topDown(WINDOW *win)
{
  if (mouse_rcintersect(win->pos.x0, win->pos.y0, win->pos.w, win->pos.h)) {
    mouse_hide();
  }

  clip0 = clip1 = NULL;

  /* fix window hierarchy */

  if (win->parent->childs == win) {
    window_to_bottom(win);
  } else {
    window_to_top(win);
  }
}


/*
 *
 */

void w_changeActiveWindow(void)
{
  WINDOW *win, *top;
  EVENTP ev;

  if (!(win = window_find (glob_mouse.real.x0, glob_mouse.real.y0, 1))) {
    /* hmmm..??? */
    return;
  }

  /*
   * find the toplevel window the mouse is in. this is now a bit more subtle
   * as we've got W_TOP windows again and even the glob_backgroundwin has a
   * parent.
   *
   * 2/98, ++eero:  W_TOP window can have children without W_TOP flag set.
   * Check for them too.
   */
  top = win;
  if (top != glob_backgroundwin && top->parent) {
    for ( ; top->parent != glob_backgroundwin; top = top->parent) {
      if (top->flags & W_TOP)
        break;
    }
  }

  if (win != glob_activewindow) {
    if (glob_activewindow->flags & EV_ACTIVE) {
      ev.len = htons(sizeof(EVENTP));
      ev.type = htons(PAK_EVENT);
      ev.event.type = htons(EVENT_INACTIVE);
      ev.event.win = glob_activewindow->libPtr;
      write(glob_activewindow->cptr->sh, &ev, sizeof(EVENTP));
    }
    glob_activewindow = win;
    if (glob_activewindow->flags & EV_ACTIVE) {
      ev.len = htons(sizeof(EVENTP));
      ev.type = htons(PAK_EVENT);
      ev.event.type = htons(EVENT_ACTIVE);
      ev.event.win = glob_activewindow->libPtr;
      write(glob_activewindow->cptr->sh, &ev, sizeof(EVENTP));
    }
    colorSetColorTable(glob_activewindow->colTab, 0);
  }

  if (glob_activetopwin != top) {
    mouse_hide();
    windowDeactivate(glob_activetopwin);
    glob_activetopwin = top;
    windowActivate(glob_activetopwin);
  }
}
